
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau61.h"
// #import "nxardn61.h"
// #import "nxprob61.h"
#import <math.h> 
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern  int binrule[KK][KK][KK];
extern char ascrule[KK][KK][KK];
extern char auxrule[KK][KK][KK];

int    drawArhi=NO;
int    drawBasin=NO;
int    drawEntpy=NO;
int    drawMonc=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawReturn=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawTMatrix=NO;
int    drawMeanF=NO;
int    draw2Block=NO;
int    drawXBlock=NO;
int    drawNBlk=NO;
int    showStat=NO;
int    drawPlaid=NO;

int    drawview=0;

int    probEIV='e';
int    probBlkV='1';

extern parneih    amat;
extern parneih    bmat;
extern parneih    cmat;
extern parneih    fmat;
extern parneih    gmat;
extern parneih    hmat;
extern parneih    xmat;

extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

int    srule[2][27];
int    cu=12;

double cubic[25][25][25];

extern NXColor colst[KK];

extern double blpr[KK];			/* probability from blocks	*/

extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];

int    ardnll;
int    plaidline[2];			/* center for plaid radius contours */
extern double stt, sta[5][K3+1];


int      ix3(int i, int j, int k);
void     shortevolve(int m, int n);
void     tcolordot(double *p, double *c);
double   tdist(int i, int j, int n);
int      totonu(int i);
void     wru(char *c);

/* from conth.c */
void   conth(double z[25][25][25], double c, int i, int j, int k, int vv);
void   cudem(double f[25][25][25], int l, int m, int n, int v);

/* from lcau.c */
void asctobin();
void evolve();
void onegen(int n);
void pgrid();
void pprob();
void ranblin(double p, double q, double r);
void ranlin();
void renewarry();
void savearry();
void xblnk();

@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videocattr(p,c,n,l) int p, c, n, l; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}

void videodot(i,j,l) int i, j, l; {
  NXSetColor(colst[l]);
			/* drawview = 5  -  Plaid Diagram	*/
    switch (drawview) {
      case 0: PSrectfill(2.0*(float)j,2.0*(float)i,1.25,1.25); break;
      case 1: PSrectfill(2.0*(float)i,398.0-2.0*(float)j,1.25,1.25); break;
      case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
      case 3: PSrectfill(4.0*(float)j+1.0,4.0*(float)i,3.0,3.0); break;
      case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(10.0*(float)j,10.0*(float)i,9.0,9.0); break;
      case 7: PSrectfill(4.0*(float)j,4.0*(float)i,3.125,3.125); break;
      case 8: PSrectfill(150.0+(float)j,260.0-(float)i,1.0,1.0); break;
      case 9: PSrectfill(2.0*(float)j,173.0-2.0*(float)i,1.5,1.5); break;
      default: break;}
 }

void tcolordot(p,c) double p[3], c[3]; {double s;
  s=1.0/(p[0]+p[1]+p[2]);
  PSsetcmykcolor(c[0],c[1],c[2],0.0);
  PSrectfill(200.0*(p[1]+0.5*p[2])*s,173.0-200.0*p[2]*s*0.866,1.5,1.5);
}

/* m = line length; n = number of lines */

void shortevolve(m,n) int m, n; {
int i, j, o;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
    for (i=0; i<m; i++) videodot(j,i,arr1[i+o]);
    onegen(AL);
    }
  renewarry();
}

/* index three dimensions */
int ix3(i,j,k) int i, j, k; {return (cu+i)%cu+ cu*((cu+j)%cu+ cu*((cu+k)%cu ));}

/* --------------------------- E V O L U T I O N --------------------------- */

- makeline:sender
{
  char *s; int i; double p, p0, p1, p2;
    s=[[sender selectedCell] title];
    printf("Line - %s\n",s);
    switch (s[0]) {
      case 'h':
//        printf("random line\n");
//        p=0.5;
	ranblin(0.33,0.33,0.34);
//        printf("%6.3f \n",p);
        break;
      case 'r':
        printf("random line\n");
        p0=[[pslid cellAt: 0: 0] floatValue];
        p1=[[pslid cellAt: 0: 0] floatValue];
        p2=[[pslid cellAt: 0: 0] floatValue];
	p=p0+p1+p2;
	p0/=p; p1/=p; p2/=p;
	ranlin();
        break;
      case 's':
        printf("single cell\n");
	    xblnk();
	    for (i=0; i<AL; i++) arr1[i]=0;
	    arr1[AL/4]=1;
            arr1[AL/2]=1;
            arr1[(3*AL)/4]=1;
            arr1[(3*AL)/4+2]=1;
/*	    lmenu(); */
        break;
      case 'z':
        printf("zero line\n");
	    xblnk();
	    for (i=0; i<AL; i++) arr1[i]=0;
/*	    lmenu(); */
	break;
      default: break;}

    drawview=2;
    drawLine=YES;
    [self display];
    drawLine=NO;

return self;
}

- drawShEvol:sender {
    drawview=7;
    drawShort=YES;
    [self display];
    drawShort=NO;

return self;
}

- printShEvol:sender {
    drawview=7;
    drawShort=YES;
    [keyWindow smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==shEvolWindow) [self printShEvol: sender];
    if (keyWindow==thEvolWindow) [self printThEvol: sender];
    if (keyWindow==evolWindow)   [self printEvolu: sender];
    if (keyWindow==probWindow)   [self printBlock: sender];
    if (keyWindow==plaidWindow)  [self printPlaid: sender];
return self;
}

- windowDidBecomeKey:sender {
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];

	keyWindow=sender;
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==shEvolWindow)  [self copyShEvol: sender];
    if (keyWindow==thEvolWindow)  [self copyThEvol: sender];
    if (keyWindow==evolWindow)    [self copyEvolu:  sender];
    if (keyWindow==plaidWindow)   [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode: self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];

return self;
}

double tdist(i,j,n) int i, j, n; {int a[10], b[10], l, m; double kay, s, t, u;
  if (n>10) return 0.0; 
  kay=1.0/((double)KK);
  for (l=0; l<n; l++) a[l]=b[l]=0;
  for (m=i, l=0; l<n; m/=KK, l++) a[n-l-1]=m%KK;
  for (m=j, l=0; l<n; m/=KK, l++) b[n-l-1]=m%KK;
  for (s=0.0, t=1.0, l=0; l<n; t*=kay, l++) {u=a[l]-b[l]; s+=t*((u<0.0)?-u:u);}
  return s*kay;
}


/* -------------------------------- L C A U -------------------------------- */

/* -------------------------------- A R D N -------------------------------- */

- arhi:sender {
    drawview=5;
    drawArhi=YES;
    [self display];
    drawArhi=NO;
  [pButton setEnabled: YES];
  [sButton setEnabled: YES];
return self;
}

/* -------------------------------- P R O B -------------------------------- */

- drawStat:sender {
    drawview=5;
    showStat=YES;
    [self display];
    showStat=NO;
return self;
}

- printStat:sender {
   drawview=5;
   showStat=YES;
//   [wholePanel smartPrintPSCode:self];
   showStat=NO;
return self;
}

- nxmoncar: (int) l {
int i, j, k, n, b[KK], bb[KK][KK];
double bf[KK], bbf[KK][KK];
double a[KK], aa[KK], d[KK], el, en, t, tt, s;

// nblclr();
n=[[statLines selectedCell] tag];
asctobin();
el=1.0/((double)AL);
en=1.0/((double)n);
for (i=0; i<KK; i++) {a[i]=0.0; aa[i]=0.0;}
for (k=0; k<n; k++) {
  onegen(AL);
  for (i=0; i<KK; i++) b[i]=0;
  for (i=0; i<AL; i++) b[arr1[i]]++;
  for (i=0; i<KK; i++) bf[i]=((double)(b[i]))*el;
  for (i=0; i<KK; i++) {a[i]+=bf[i]; aa[i]+=bf[i]*bf[i];}
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) bb[i][j]=0;
  for (i=1; i<AL; i++) bb[arr1[i-1]][arr1[i]]++;
  bb[arr1[AL-1]][arr1[0]]++; 
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
    bbf[i][j]=((double)(bb[i][j]))*el;
//  videodot(199-(int)(100.0*bbf[1][1]),BORG+(int)(100.0*bf[1]),l);
  }
for (i=0; i<KK; i++) {a[i]*=en; aa[i]*=en;}
s=1.0/log((double)KK);
t=0.0; tt=0.0;
for (i=0; i<KK; i++) t+=bf[i]*log(bf[i]);
for (i=0; i<KK; i++) d[i]=sqrt(aa[i]-a[i]*a[i]);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) tt+=bbf[i][j]*log(bbf[i][j]);
  [statLamb setDoubleValue: 1.0-bf[0]];
  [statEntro setDoubleValue: -t*s];
  [statEnpai setDoubleValue: -0.5*tt*s];
 printf("average      = %5.3f, %5.3f, %5.3f\n",a[0],a[1],a[2]);
 printf("deviation    = %5.3f, %5.3f, %5.3f\n",d[0],d[1],d[2]);
	[statSDevi setDoubleValue: (d[0]+d[1]+d[2])/3.0];
  for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: bf[i]];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
	[[statPair cellAt: i: j] setDoubleValue: bbf[i][j]];
	[[statProd cellAt: i: j] setDoubleValue: bf[i]*bf[j]];
	}
return self;
}


/* - - - - - - - - - - -   L C A U V i e w   - - - - - - - - - - - - - - - - */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = 
		[NXCursor newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

  [self setFlipped: YES];

	return self;

}


- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	unsigned int	 i, j, k, l, n;
	int		 ii, jj, nn, bas;
        double           en, p, q, r, s, t, dp, pee, cue;
	NXPoint		 *aPoint;
	NXRect		 plotRect;

  struct tm  *timeptr;
  time_t  secsnow;

int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	NXRectFill(&rects[0]);

//	PSsetgray(NX_DKGRAY);
// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);


        if (drawEvol==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
	  if ([keepTop state]) savearry();
	  evolve();
	  if ([keepTop state]) renewarry();
	  }

        if (drawShort==YES) {
   if (istot()) sprintf(c,"Totalistic %10d",totonu(0)); else wru(c);
   [ruleNumber setStringValue: c];
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}

        if (drawThird==YES) {
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/10.0);
	  j=(int)(plotRect.size.height/10.0);
	  shortevolve(i,j);
	  }

	if (drawPlaid==YES) {}

        if (drawMeanF==YES) {}

	if (drawBasin==YES) {}

	if (drawEntpy==YES) {}

	if (draw2Block==YES) {}

	if (drawXBlock==YES) {}

	if (drawNBlk==YES) {}

	if (showStat==YES) {}

        if (drawArhi==YES) {}

	if (drawTMatrix==YES) {}

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==6||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	else 
		[self setDrawOrigin: -floor(width/2): -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect;

         double  x, y, ex, wy, eks, wye;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);
	plaidline[0]=(int)ex;
	plaidline[1]=243-(int)wy;

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				cntr[k][0]=ex;
//				cntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {looping = NO;}
   	} while (looping && 
	  (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- read:(NXTypedStream *)stream
/*
 * Unarchives the LCAUView.  Initializes four of the LCAUView's instance 
 * variables to the values stored in the stream. 
 */
{
	[super read:stream];
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LCAUView by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	return self;
}

- awake
/*
 * Finishes initializing a LCAUView that has just been unarchived (see the 
 * read: method).
 */
{
	return [super awake];
}


- (const char *)inspectorName
{
    return "LCAUViewInspector";
}


@end

/* end LCAUView.m */
