
/* 
 * RulePanel.h -- Interface file for the RulePanel class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface RulePanel:View {

/* Rule Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */

	id		infoPanel;
	id		mainWindow;
	id		menuCopy;
	id		menuPrint;
	id		nowBox;
	id		nowSpesh;
	id		speshPanel;

/* panel control - - - - - - - - - - - - - - - - - - - - - - - - */

	id		arithmRuleBox;
	id		composRuleBox;
	id		equivRuleBox;
	id		specBigBox;
	id		specLilBox;
	id		subsetRuleBox;

/* Main Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */

	id		ascru;
	id		changeLine;
	id		pSliders;
	id		pWindows;
	id		RECLine;
	id		RECPanel;
	id		RECValue;
	id		ruleBox;
	id		ruleNumber;
	id		totlRef;
	id		sIncr;
	id		tiDat;
	id		wrule;

	id		S00,S01,S02,S10,S11,S12,S20,S21,S22;

	id		gfWindow;
	id		ruleFormula;

/* semitotalistic Window  - - - - - - - - - - - - - - - - - - - */

	id		stRuleNumber;
	id		stWindow;

/* totalistic rules  - - - - - - - - - - - - - - - - - - - - - */

	id		toascru;
	id		toRuleBox;
	id		toRuleNumber;
	id		toWindow;

/* xenophobic Window  - - - - - - - - - - - - - - - - - - - - - */

	id		obBnry;
	id		obPerm;

/* equivalence Box  - - - - - - - - - - - - - - - - - - - - - - */

	id		eqChoices;
	id		eqFactor;
	id		eqPair;

/* arithmetic Box   - - - - - - - - - - - - - - - - - - - - - - */

	id		twoRules;

/* composite Box  - - - - - - - - - - - - - - - - - - - - - - - */

	id		composRuleNumb;	

/* rule trivia  - - - - - - - - - - - - - - - - - - - - - - - - */

	id		statEntro;
	id		statPEntro;
	id		statIndx;
	id		statLamb;
	id		statPairs;
	id		statState;
	id		statXeno;

/* design Window  - - - - - - - - - - - - - - - - - - - - - - - */

	id		ddWindow;
	id		designPrm;
	id		designRef;
	id		zeZeZe;

}

- loadSpecialRule:sender; 
- loadLowerPanel:thisRuleBox; 

- freeAllRules:sender;
- protectGenRule:sender;
- ranRules:sender;
- ranPRules:sender;
- relatedRule:sender;
- readWRule:sender;
- runRECLine:sender;
- setAllRules:sender;
- setDemo:sender;
- setRule:sender; 
- showProbability:sender;
- symRule:sender;
- useRecLine:sender;
- zeroRules:sender; 

- randomLine:sender;
- sCellLine:sender;
- uniformLine:sender;

- enterGF5Rule:sender; 
- setMCoeff:sender;
- setSCoeff:sender;
- setVCoeff:sender;

- enterSemiRule:sender;
- setSemiState:sender;

/* Totalistic Rule  - - - - - - - - - - - - - - - - - - - - - */
- enterTotalisticRule:sender;
- ranTRule:sender;
- readTRule:sender;
- setTotalisticState:sender;
- setTotRule:sender;
- setTotRules:sender;

- equivalence:sender;
- ranqul:sender;

- arithmCombs:sender;
- initTwoRules:sender; 

- composRule:sender;
- compxRule:sender;
- comprRule:sender;

- randphobic:sender; 
- xenophilic:sender;
- xenophobic:sender;

- clearDesign:sender;
- copyToDesign:sender;
- deZign:sender;
- enterDesign:sender;

- nxasfreq; 

@end 

/* end RulePanel.h */ 
