
#import "RulePanel.h"
#import "nxlcau61.h"
#import <string.h>
#import <time.h>
#import "rec.h"

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern birular binrule;
extern char ascrule[KK][KK][KK];
extern char auxrule[KK][KK][KK];
extern char gf3rule[13];		/* coefficients of GF3 rule	*/
extern char ttrule[TS];			/* totalistic rule		*/
extern char tarule[TS];
extern char strule[KK][SS];		/* semitoralistic rule		*/
extern char sarule[KK][SS];

extern struct fptbl dtbl[];
extern Inst   xprg[][XLEN];
extern char   idef[][30];

const char *sendTypes[2];
const char *returnTypes[2];

int     allperm(char wn[][WNML], char ii[][KK][KK][KK], char ru[KK][KK][KK]);
void    asctobin();
void    asctotot();
void	asczero();
void	auxzero();
void    bincopy(birular *rz, birular rx);
void    binprint(birular rz);
void    binprod(birular *rz, birular rx, birular ry);
void    binsum(birular *rz, birular rx, birular ry);
void    bintoasc();
void    chrucopy(char ii[KK][KK][KK], char jj[KK][KK][KK], int c);
void    clumin(char *c);
int     cyy(int i);
int     cuu(int i);
int     cvv(int i);
int     czz(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
int     longtwolftoasc(char *c);
int     longwolftoasc(char *c);
void    numtobin3h(int ru[KK][KK], int n);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(birular *pr, birular *br, int k);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p0,
		double p1,
		double p2,
		double p3,
		double p4,	
		double p5);
void    ranvachrul(char *c);
int     rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
int     rec_x(Inst rprg);
void	runowows(char x[2][2][2], int n);
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    ttzero();
int     ucc(int i);
int     vcc(int i);
int     vecperm(int ii[KK], int n);
int     wolbin(int a, int b);
void    wolnum(char ii[KK][KK][KK], int c);
void    wru(char *c);
void    wrru(char *c, char ru[KK][KK][KK]);
void	xtoasc(int n);
int     ycc(int i);
int     zcc(int i);

char    xr[DS] = "121220101221200000101000100";
char    xp[DS] = "532337242335361411252611214"; /* xenophilic	*/
char    xq[DS] = "135337575337326766575766564"; /* xenophobic	*/
char    xs[DS] = "135135135326326326564564564"; /* s-xenophobic */
char	xt[DS] = "642642642451451451213213213"; /* s-xenophilic	*/

#include "permute.c"				/* permutation tables */

@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
//  if (strcmp(ch,"composite")==0)   [self loadLowerPanel: compRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
//  if (strcmp(ch,"product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"subset")==0)      [self loadLowerPanel: subsetRuleBox];
//  if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox 
{NXRect bxRect, loRect;
 id cv;
 cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",[[cv subviews] count]);
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=toRuleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender {int i, j, k, i0, i1, i2;
  i=j=[sender selectedCol];
  i2=i%KK; i/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1][i2];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2]=!k;
return self;
}

- relatedRule:sender
{
char ii[RSYM][KK][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int     j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"reflected")==0) k=RSYM/2;

  else if (strcmp(titl,"6-cycle")==0)   k=1;
  else if (strcmp(titl,"5-cycle")==0)   k=6;
  else if (strcmp(titl,"4-cycle")==0)   k=30; 
  else if (strcmp(titl,"3-cycle")==0)   k=120; 
  else if (strcmp(titl,"2-cycle")==0)   k=360; 
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"least")==0)     k=l;
  else  				k=0;
   if (k==RSYM) {
    clumin(c);
    longwolftoasc(c);
    [self setAllRules: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  if ([changeLine state]) {
    l=vecperm(jj,k);
    for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
    if (l) {
      for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
      for (j=0; j<AL; j++) arr1[j]=arr2[j];
      }
    }
return self;
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n;
{int i, k, l;
  l=!(n<RSYM/2); k=(l?n-(RSYM/2):n);
   for (i=0; i<KK; i++) ii[i]=permu[k][i];
  return l;
}

/*  generate a table of permutations of a given rule      */
/*  and report the index of the rule with smallest wru    */
/*  wn - array to be filled with 18-letter wolfram numbers */
/*  ii - array to be filled with ascrule symmetry images  */
/*  ru - reference KK8KK table - e.g. ascrule          */
/*  return value is the index of the least of all these   */
/*  that is, wn[...] is the number, ii[...] is the rule   */
int allperm(wnum,ii,ru) 
  char wnum[][WNML], ii[][KK][KK][KK], ru[KK][KK][KK]; {int i,l,k;

  chrucopy(ii[0],ru,'w');				/* identity */
  for(i=1; i<KK; i++) chrucopy(ii[i],ii[i-1],'u');	/* 6-cycles */
  for(i=KK; i<5*KK; i++) chrucopy(ii[i],ii[i-KK],'v');	/* 5-cycles */
  for(i=5*KK; i<20*KK; i++) chrucopy(ii[i],ii[i-5*KK],'y');/* 4-cycles */
  for(i=20*KK; i<RSYM/4; i++) chrucopy(ii[i],ii[i-20*KK],'z');/* 3-cycles */
  for(i=RSYM/4; i<RSYM/2; i++) chrucopy(ii[i],ii[i-RSYM/4],'t');/* 2-cycles */
  for (i=RSYM/2; i<RSYM; i++) chrucopy(ii[i],ii[i-RSYM/2],'r'); /* reflect  */
  for(k=0, l=0; k<RSYM; k++) {
      wrru(wnum[k],ii[k]);     /* calcula el numero de Wolfram */
      if(strcmp(wnum[k],wnum[l]) < 0) l=k;
      }
   return l;
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* copy a related (character) rule */
/* c = w - no change              */
/* c = u - 6 cyclic permutation   */
/* c = v - 5 cyclic permutation   */
/* c = y - 4 cyclic permutation   */
/* c = z - 3 cyclic permutation   */
/* c = t - transpose (2 cyclic permutation)*/
/* c = r - reflected               */


void chrucopy(ii,jj,c) char ii[KK][KK][KK], jj[KK][KK][KK], c; {
int i0, i1, i2;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
     	ii[i0][i1][i2]=jj[i0][i1][i2];
      break;
    case 'u':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
     	ii[i0][i1][i2]=ucc(jj[cuu(i0)][cuu(i1)][cuu(i2)]);
      break;
    case 'v':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
     	ii[i0][i1][i2]=vcc(jj[cvv(i0)][cvv(i1)][cvv(i2)]);
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
     	ii[i0][i1][i2]=ycc(jj[cyy(i0)][cyy(i1)][cyy(i2)]);
      break;
    case 'z':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
     	ii[i0][i1][i2]=zcc(jj[czz(i0)][czz(i1)][czz(i2)]);
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      	ii[i0][i1][i2]=fli(jj[fli(i0)][fli(i1)][fli(i2)]);
    break;

    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
     	ii[i0][i1][i2]=jj[i2][i1][i0];
    break;
    default: break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '1';
        case '1': return '0';
        case '2': return '2';
	case '3': return '3'; 
	case '4': return '4';
        case '5': return '5';
        case  0 : return  1 ;
        case  1 : return  0 ;
        case  2 : return  2 ;
	case  3 : return  3 ; 
	case  4 : return  4 ;
        case  5 : return  5 ;
	default:  return '0';}
}

int cuu(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '5';
        case '5': return '0';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
        case 4: return 5;
	case 5: return 0;
	default:  return '0';}
}

int ucc(i) int i; {switch (i) {
	case '0': return '5';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
        case '5': return '4';
	case 0: return 5;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
        case 5: return 4;
	default:  return '0';}
}

int cvv(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '0';
        case '4': return '4';
        case '5': return '5';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 0; 
	case 4: return 4;
        case 5: return 5;
	default:  return '0';}
}

int vcc(i) int i; {switch (i) {
	case '0': return '3';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '4';
        case '5': return '5';
	case 0: return 3;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 4;
        case 5: return 5;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '0';
        case '4': return '4';
        case '5': return '5';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 0; 
	case 4: return 4;
        case 5: return 5;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '3';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '4';
        case '5': return '5';
	case 0: return 3;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 4;

       case 5: return 5;
	default:  return '0';}
}

int czz(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '0';
        case '3': return '3';
        case '4': return '4';
        case '5': return '5';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 0;
        case 3: return 3; 
	case 4: return 4;
        case 5: return 5;
	default:  return '0';}
}

int zcc(i) int i; {switch (i) {
	case '0': return '2';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '3';
        case '4': return '4';
        case '5': return '5';
	case 0: return 2;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 3; 
	case 4: return 4;

       case 5: return 5;
	default:  return '0';}
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {return self;}

-readWRule:sender {char *c; int l;
  c=[sender stringValue];
  l=strlen(c);
  if (l>=WNML) {[ruleNumber setStringValue: "exceeded "]; return self;}
  if (longwolftoasc(c)) [self setAllRules: self];
     else[ruleNumber setStringValue: "invalid"];
  return self;
}

int longwolftoasc(char *c) {  
char d[WNML], e;
int i, l, n, k1, k2, k3;
  l=strlen(c);
  k1=0;
  k2=0;
  k3=0;
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
       e=c[i];
             if ('0' <= e  &&  e <= '9') n=e-'0';
        else if ('a' <= e  &&  e <= 'z') n=e-'a'+10;
        else if ('A' <= e  &&  e <= 'Z') n=e-'A'+10;
        else return FALSE;
    d[WNML-l-1+i]=n; 
 }
 for (i=0; i<WNML-1; i++) { 
    n=d[WNML-i-2];
    ascrule[k1][k2][k3]='0'+n%KK; n/=KK; k3++;
    if (k3==KK) {k2++; k3=0;} if (k2==KK) {k1++; k2=0;} if (k1==KK) break;
    ascrule[k1][k2][k3]='0'+n%KK; k3++;
    if (k3==KK) {k2++; k3=0;} if (k2==KK) {k1++; k2=0;} if (k1==KK) break;
    }
return TRUE;
} 

- setRule:sender 
{char ch[WNML]; int i, ii, j, jj, i0, i1, i2;
   wru(ch);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i2=j%KK; j/=KK;
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1][i2]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- setAllRules:sender 
{char ch[WNML]; int i, j, i0, i1, i2;
//   wru(ch);
//   [ruleNumber setStringValue: ch];
  asctobin();
//  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
//    j=KK*(KK*i0+i1)+i2;
//    for (i=0; i<KK; i++) {
//      [[ascru cellAt: i: j] setIntValue: NO];
//      if (auxrule[i0][i1][i2]) [[ascru cellAt: i: j] setEnabled: NO];
//      if (auxrule[i0][i1][i2]) [[ascru cellAt: i: j] setBordered: NO];
//      }
//    [[ascru cellAt: binrule.three[i0][i1][i2]: j] setIntValue: YES];
//    }
   wru(ch);
   [ruleNumber setStringValue: ch];
//   [self nxasfreq];
   if      (istot()==1) {asctotot(); [self setTotRules: self];}
//    else if (isstot()==1) [totlRef setStringValue: "semitotalistic"];
      else {
	[toascru setEmptySelectionEnabled: YES];
	[toascru selectCellAt: -1: 0];
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
   [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {granrule(); [self setAllRules: self]; return self;}

- ranPRules:sender {granprule(); [self setAllRules: self]; return self;}

/* for 6-state automata, group the neighborhoods by twos and  */
/* use ASCII letters base 36 - that is, 0-9, A-Z.	      */
void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument rule */
void wrru(c, ru) char *c, ru[KK][KK][KK]; {
int  i, j, k, l, m;
k=0; j=0; l=0; m=0;
while (TRUE) {
  i=(ru[j][k][l]-'0')+'0'; 
  l++; if (l>=KK) {l=0; k++;} if (k>=KK) {k=0; j++;} if (j>=KK) break;
  i+=KK*(ru[j][k][l]-'0');
  if (i>'9') i=i+('A'-':');
    c[WNML-1-m-1]=i;
  l++; if (l>=KK) {l=0; k++;} if (k>=KK) {k=0; j++;} if (j>=KK) break;
  m++;
  }
c[0]=i;
c[WNML-1]=0; 
}

/* generate a random rule */
void granrule() {int i, i0, i1, i2;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  i=(random()&0xFF)%KK;
  ascrule[i0][i1][i2]=i+'0';
  }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1][i2]==0) ascrule[i0][i1][i2]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender {double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2],p[3],p[4],p[5]);
return self;
}

- sCellLine:sender {putionj(1,0); return self;}

- uniformLine:sender {ranblin(0.16,0.16,0.16,0.16,0.16,0.16); return self;}

- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
return self;
}

- runRECLine:sender; {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [self setAllRules: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}

/* - - - - - - - -   D E M O N S T R A T I O N   R U L E S   - - - - - - - - */

- setDemo:sender {char ch[WNML];
   wru(ch);
   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender {
//   asctobin();
//   ptedbrul(&binrule,&binrule,[pRu intValue]);
//   [self setAllRules:self];
// return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; {
int i;
  for (i=0; i<KK*KK*KK; i++) pr->one[i]=permu[k][br->one[i]];
}

/* - - - - - - - - - - - - -   G F ( 6 )   R U L E   - - - - - - - - - - - - */

/* there is no GF(6) ----- */

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    strule[t%KK][t/KK]=s+'0';
    [toWindow setDocEdited:YES];
    sttoasc();
  return self;
  }
 
- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited: YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited: NO];
return self;
}

- readTRule:sender {
  if (longtwolftoasc([sender stringValue])) {
	totoasc();
	[self setAllRules: self];
	} else [sender setStringValue: "invalid"];
return self;
}

int longtwolftoasc(char *c) {  
char d[TS], e;
int i, l, n, k;
  l=strlen(c);
  k=0;
  for (i=0; i<TS; i++) d[i]=0;
  for (i=0; i<l; i++) {
       e=c[i];
             if ('0' <= e  &&  e <= '9') n=e-'0';
        else if ('a' <= e  &&  e <= 'z') n=e-'a'+10;
        else if ('A' <= e  &&  e <= 'Z') n=e-'A'+10;
        else return FALSE;
    d[TS-l+i]=n; 
    }
 for (i=0; i<TS; i++) { 
    n=d[TS-i-1];
    ttrule[k]='0'+n%KK; n/=KK; k++;
    if (k==TS) break;
    ttrule[k]='0'+n%KK; k++;
    if (k==TS) break;
    }
return TRUE;
} 

/* calculate base 36 totalistic rule number */
void wtrru(c, ru) char *c, ru[TS]; {
int  i, j, k, m;
j=0; m=0; k=((TS)%2==0)?(TS)/2+1:(TS)/2+2;
while (TRUE) {
  i=(ru[j]-'0')+'0'; 
  j++; if (j>=TS) break;
  i+=KK*(ru[j]-'0');
  if (i>'9') i=i+('A'-':');
    c[k-1-m-1]=i;
  j++; if (j>=TS) break;
  m++;
  }
c[0]=i;
c[k-1]=0; 
}

- setTotRule:sender {
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
  [self setTotRules: self];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
  wru(ch);
  [ruleNumber setStringValue: ch];
  totoasc();
  asctobin();
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  wru(ch);
  [ruleNumber setStringValue: ch];
//  [self nxasfreq];
   if      (istot()==1) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
//    else if (isstot()==1) [totlRef setStringValue: "semitotalistic"];
      else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranTRule:sender {int i;
  for (i=0; i<TS; i++) ttrule[i]=(random()&0xFF)%KK+'0';
  totoasc();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i2, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) {
              if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1][i2]==0) 
		ascrule[i0][i1][i2]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

/*
 *	subset  code
 *	------  ----
 *	empty - 0
 *	0	1
 *	1	2
 *	2	4
 *	0,1	3
 *	0,2	5
 *	1,2	6
 *	0,1,2	7
 *
 *     rule     --- phobic  -- philic  -- sphobic  -- sphilic
 *	000     0      (1)  1,2   (6)  0      (1)  1,2   (6)  
 *	001	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	002	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 
 *	010	0,1    (3)  2     (4)  0      (1)  1,2   (6)  
 *	011	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	012	0,1,2  (7)  	  (0)  0,2    (5)  1	 (2) 
 *	020	0,2    (5)  1     (2)  0      (1)  1,2   (6)  
 *	021	0,1,2  (7)  	  (0)  0,1    (3)  2     (4)  
 *	022	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 
 *	100	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	101	0,1    (3)  2     (4)  1      (2)  0,2   (5)  
 *	102	0,1,2  (7)  	  (0)  1,2    (6)  0	 (1) 
 *	110	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	111	1      (2)  0,2   (5)  1      (2)  0,2   (5)  
 *	112	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	120	0,1,2  (7)        (0)  0,1    (3)  2     (4)  
 *	121	1,2    (6)  0     (1)  1      (2)  0,2   (5)  
 *	122	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 	
 *	200	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 	
 *	201	0,1,2  (7)  	  (0)  1,2    (6)  0	 (1) 
 *	202	0,2    (5)  1     (2)  2      (4)  0,1   (3)  
 *	210	0,1,2  (7)  	  (0)  0,2    (5)  1	 (2) 
 *	211	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	212	1,2    (6)  0     (1)  2      (4)  0,1   (3)  
 *	220	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 	
 *	221	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	222	2      (4)  0,1   (3)  2      (4)  0,1   (3)  
 */ 

- xenophilic:sender {
  ranvachrul(xt);
  [self setAllRules: self];
return self;
}

- xenophobic:sender 
{int i, k, i0, i1, i2, ix[2]; char ru[3][2][2][2];
  for (i=0; i<3; i++) runowows(ru[i],[[obBnry cellAt: i: 0] intValue]);
  for (i=0, k=0; i<3; i++) if (ru[i][0][0][0]==ru[i][1][1][1]) 
	{[[obBnry cellAt: i: 0] setStringValue: "***"]; k=1;}
  if (k==1) return self;
  ascrule[0][0][0]='0';
  ascrule[1][1][1]='1';
  ascrule[2][2][2]='2';
  ix[0]=0; ix[1]=1;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[0][i0][i1][i2]-'0']+'0';
  ix[0]=2; ix[1]=0;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[1][i0][i1][i2]-'0']+'0';
  ix[0]=1; ix[1]=2;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[2][i0][i1][i2]-'0']+'0';
  ascrule[0][1][2]=[[obPerm cellAt: 0: 0] intValue]+'0';
  ascrule[0][2][1]=[[obPerm cellAt: 1: 0] intValue]+'0';
  ascrule[1][0][2]=[[obPerm cellAt: 2: 0] intValue]+'0';
  ascrule[1][2][0]=[[obPerm cellAt: 3: 0] intValue]+'0';
  ascrule[2][0][1]=[[obPerm cellAt: 4: 0] intValue]+'0';
  ascrule[2][1][0]=[[obPerm cellAt: 5: 0] intValue]+'0';
  [self setAllRules: self];
return self;
}

- randphobic:sender {
  ranvachrul(xq);
  [[obPerm cellAt: 0: 0] setIntValue: ascrule[0][1][2]-'0'];
  [[obPerm cellAt: 1: 0] setIntValue: ascrule[0][2][1]-'0'];
  [[obPerm cellAt: 2: 0] setIntValue: ascrule[1][0][2]-'0'];
  [[obPerm cellAt: 3: 0] setIntValue: ascrule[1][2][0]-'0'];
  [[obPerm cellAt: 4: 0] setIntValue: ascrule[2][0][1]-'0'];
  [[obPerm cellAt: 5: 0] setIntValue: ascrule[2][1][0]-'0'];
  asctobin();
  [[obBnry cellAt: 0: 0] setIntValue: wolbin(0,1)];
  [[obBnry cellAt: 1: 0] setIntValue: wolbin(0,2)];
  [[obBnry cellAt: 2: 0] setIntValue: wolbin(1,2)];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule */
void ranvachrul(c) char *c; {int i0, i1, i2, i;
i=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  switch (c[KK*(KK*i0+i1)+i2]-'0') {
    case 0: break;
    case 1: i=0; break;
    case 2: i=1; break;
    case 4: i=2; break;
    case 3: i=ran2of3(0,1); break;
    case 6: i=ran2of3(1,2); break;
    case 5: i=ran2of3(2,0); break;
    case 7: i=ran3of3(0,1,2); break;
    default: i=0; break;}
    ascrule[i0][i1][i2]='0'+i;
  }
}

- allClans:sender 
{int i, j, k, i0, i1, i2, i3, i4, i5, ix[2];
char ru[3][2][2][2], ch[WNML];
char ii[12][KK][KK][KK], wnum[RSYM][WNML];
  for (i=0; i<(KK*(KK-1))/2; i++) runowows(ru[i],150);
  ascrule[0][0][0]='0';
  ascrule[1][1][1]='1';
  ascrule[2][2][2]='2';
  ix[0]=0; ix[1]=1;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[0][i0][i1][i2]-'0']+'0';
  ix[0]=2; ix[1]=0;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[1][i0][i1][i2]-'0']+'0';
  ix[0]=1; ix[1]=2;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[2][i0][i1][i2]-'0']+'0';
  j=0;
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) 
  for (i5=0; i5<KK; i5++) {
     ascrule[0][1][2]=i0+'0';
     ascrule[0][2][1]=i1+'0';
     ascrule[1][0][2]=i2+'0';
     ascrule[1][2][0]=i3+'0';
     ascrule[2][0][1]=i4+'0';
     ascrule[2][1][0]=i5+'0';
     k=allperm(wnum,ii,ascrule);
     wru(ch);
     printf("%3d: %s   %s\n",++j,ch,wnum[k]);
    }
return self;
}

/* - - - - - - - - -    E Q U I V A L E N C E   R U L E    - - - - - - - - - */

- equivalence:sender 
{char ru[2][2][2], iy[2], iz; int i, i0, i1, i2, ix[KK], choi, p;
  runowows(ru,[eqFactor intValue]);
  choi=[eqChoices intValue];
  p=[eqPair selectedRow];
  switch (p) {
    case 0:  ix[0]=0; ix[1]=0; ix[2]=1;
	     iy[0]='0'; iy[1]='1';
	     iz='2'; break;
    case 1:  ix[0]=0; ix[1]=1; ix[2]=0;
	     iy[0]='0'; iy[1]='2';
	     iz='1'; break;
    case 2:  ix[0]=1; ix[1]=0; ix[2]=0;
	     iy[0]='1'; iy[1]='2';
	     iz='0'; break;
    default: printf("unidentified pair\n"); break;}
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    i=ru[ix[i0]][ix[i1]][ix[i2]];
    ascrule[i0][i1][i2]=(i=='0'?iy[choi%2]:iz);
    choi/=2;
    }
  [self setAllRules: self];
return self;
}

- ranqul:sender {
  switch ([sender selectedRow]) {
    case 0: [eqFactor setIntValue: random()%16]; break;
    case 1: [eqChoices setIntValue: random()%16]; break;
    default: printf("unidentified random choice\n"); break;}
return self;
}

/* - - - - - -    A R I T H M E T I C   C O M B I N A T I O N    - - - - - - */

- arithmCombs:sender {
birular aza, bzb, czc;
  [self readWRule: [twoRules cellAt: 0: 0]];
  asctobin();
  bincopy(&aza,binrule);
  binprint(aza);
  [self readWRule: [twoRules cellAt: 1: 0]];
  asctobin();
  bincopy(&bzb,binrule);
  binprint(bzb);
  switch ([sender selectedRow]) {
    case 0: binsum(&czc,aza,bzb); break;
    case 1: binprod(&czc,aza,bzb); break;
    default: printf("arithCombs\n"); break;}
  binprint(czc);
  bincopy(&binrule,czc);
  bintoasc();
  [self setAllRules: self];
  binprint(binrule);
return self;
}

- initTwoRules:sender {char ch[WNML];
   granrule();
   wru(ch);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
return self;
}

/* copy one binary rule from another */
void bincopy(rz,rx) birular *rz, rx;
{int i; for (i=0; i<KK*KK*KK; i++) rz->one[i]=rx.one[i];}

/* fill ascrule from binrule */
void bintoasc() 
{int i0, i1, i2; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
    ascrule[i0][i1][i2]=binrule.three[i0][i1][i2]+'0';
}

/* sum two binary rules mod KK */
void binsum(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<KK*KK*KK; i++) rz->one[i]=(rx.one[i]+ry.one[i])%KK;}

/* multiply two binary rules mod KK */
void binprod(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<KK*KK*KK; i++) rz->one[i]=(rx.one[i]*ry.one[i])%KK;}

/* print a binary rule (all 27 numbers) */
void binprint(rz) birular rz; {int i;
for (i=0; i<KK*KK*KK; i++) printf("%c",rz.one[i]+'0');
printf("\n");
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
    [ddWindow setDocEdited:YES];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    [z setIntValue: ascrule[i0][i1][i2]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1][i2]=(k<KK?k:0)+'0';
    auxrule[i0][i1][i2]=(k<KK?1:0);
    }
  [self setAllRules: self];
  [ddWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - - -  C O M P O S I T E   R U L E  - - - - - - - - - - - */

- composRule:sender 
{int ru1, ru2, ru3, i0, i1, i2, br1[KK][KK], br2[KK][KK], br3[KK][KK];
  ru1=[[composRuleNumb cellAt: 0: 0] intValue];
  ru2=[[composRuleNumb cellAt: 1: 0] intValue];
  ru3=[[composRuleNumb cellAt: 2: 0] intValue];
  numtobin3h(br1,ru1);
  numtobin3h(br2,ru2);
  numtobin3h(br3,ru3);
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) 
    ascrule[i0][i1][i2]=br3[br1[i0][i1]][br2[i1][i2]]+'0';
  [self setAllRules: self];
return self;
}

- compxRule:sender {int i;
  i=[[composRuleNumb cellAt: 0: 0] intValue];
  [[composRuleNumb cellAt: 0: 0] setIntValue: 
	[[composRuleNumb cellAt: 1: 0] intValue]];
  [[composRuleNumb cellAt: 1: 0] setIntValue: i];
return self;
};

- comprRule:sender {
  [[composRuleNumb cellAt: 0: 0] setIntValue: random()%19683];
  [[composRuleNumb cellAt: 1: 0] setIntValue: random()%19683];
  [[composRuleNumb cellAt: 2: 0] setIntValue: random()%19683];
return self;
}

void numtobin3h(ru,n) int ru[KK][KK], n; {
int i, j, i0, i1;
i=n;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  j=i%KK; i/=KK;
  ru[i0][i1]=j;
  }
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, k, i0, i1, i2, i3;
int    stat[KK], statp[KK][KK];			/* statistic counts */
int    shif[RR];				/* shift counts	    */
int    xe;					/* xenophobic count */
double staf[KK], stapf[KK][KK], t, pp, qq;

xe=0;
pp=1.0/((double)(DS));
qq=pp/((double)KK);
for (i=0; i<RR; i++) shif[i]=0;
for (i=0; i<KK; i++) {stat[i]=0; for (j=0; j<KK; j++) statp[i][j]=0;}
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  j=ascrule[i0][i1][i2]-'0';
  stat[j]++;
  if (j==i0) shif[0]++;
  if (j==i1) shif[1]++;
  if (j==i2) shif[2]++;
  if (j==i0 || j==i1 || j==i2) xe++;
  for (i3=0; i3<KK; i3++) {
    k=ascrule[i1][i2][i3]-'0';
    statp[j][k]++;
    }
  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
for (i=0; i<RR; i++) 
	[[statIndx cellAt: 0: i] setDoubleValue: ((double)shif[i])*pp];
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
[statLamb setDoubleValue: 1.0-staf[0]];
[statEntro setDoubleValue: -t/log((double)KK)];
for (i=0, t=0.0; i<KK; i++) for (j=0; j<KK; j++) {
  stapf[i][j]=((double)statp[i][j])*qq;
  [[statPairs cellAt: i: j] setDoubleValue: stapf[i][j]];
  t+=stapf[i][j]*log(stapf[i][j]);
  }
[statPEntro setDoubleValue: -t/log((double)(KK*KK))];
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
return self;
}

@end

/* end RulePanel.m */
