
/* nxardn61.c						*/
/* program for lcau61 option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/
/* adapted for NeXTSTEP 5 May 1994			*/

/*  Copyright (C) 1990	*/
/*  Copyright (C) 1994	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau61.h"
# include "nxardn61.h"

extern int  binrule[KK][KK][KK];

# define LUR		 1	/* left panel upper left row */
# define LUC		 0	/* left panel upper left col */
# define LLC		15	/* left panel lower right col */
# define RUR		 1	/* right panel upper left row */
# define RUC		16	/* right panel upper left col */
# define RLR		21	/* right panel lower right row */
# define RLC		39	/* right panel lower right col */

# define CUR		 1	/* cycle panel upper left row */
# define CUC		 0	/* cycle panel upper left col */
# define CLR		24	/* cycle panel lower right row */
# define CLC		39	/* cycle panel lower right col */

# define EROW		23	/* row for sample evolution */

int     allperm(char wn[][10], char ii[][KK][KK][KK], char ru[KK][KK][KK]);

char asqrule[KK][KK][KK];

char lbuf[81];

extern parneih    amat;
extern parneih    bmat;
extern parneih    cmat;
extern parneih    fmat;
extern parneih    gmat;
extern parneih    hmat;
extern parneih    xmat;

extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

double stt, sta[5][K3+1];

/* edit the Garden of Eden and ancestor screen */
void edard() {
char c;
int    l, ll, m;
int    i0, i1;
int    s0, s1, s2;
int    t0, t1, t2;
int    ss, tt;
double bb, e, f, ff, g, gg;
double h, kay, kk4;
double ex, wy, go, gr, gl;
double cave, csig, xave, xsig; 
double cvec[K4], xvec[K4];
unsigned int a, b, s, t;
unsigned int tsum(), ttsum();
unsigned int nzel(), nnzel();

// videomode(COLGRAF);
// videopalette(YELREGR);
// videocursor(0,0,0);
// scrrul();
// woruno(0,22);
// videoscroll(1,0,24,39,0,0);
asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);
zmat(&bmat);  djmat(&cmat,2);
zzmat(&tmat); tensq(&tmat,&amat,&bmat,&cmat);
unmat(&umat);
zmat(&gmat);
zmat(&xmat);
stt=0.0;
kk4=(double)K4;
l=m=ss=tt=ll=0;
kay=(double)KK;
s0=nzel(&amat);
t0=tsum(&amat);
s1=nzel(&bmat);
t1=tsum(&bmat);
s2=nzel(&cmat);
t2=tsum(&cmat);
clard();
videocursor(0,14,0); sprintf(lbuf,"a=%3u, b=%3u",t0,t1); PSshow(lbuf);
  while (0<1) {
  videocursor(0,0,36);  videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,38);  videoputc(c,2);
  videocursor(0,0,36);  videoputc(' ',2);
  videocursor(0,0,0);
  switch (c) {

    case 'a':
	l=1;
	gmat=amat;
	pmat(&gmat,8,5);
	videocursor(0,14,0); sprintf(lbuf,"%4u (%2u) %5u",t0,s0,1); PSshow(lbuf);
	break;
    case 'b':
	l=1;
	gmat=bmat;
	pmat(&gmat,8,5);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t1,s1,1);
	break;
    case 'c':
	l=1;
	gmat=cmat;
	pmat(&gmat,8,5);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t2,s2,1);
	break;
    case 'x':
	l=m;
	gmat=xmat;
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,1);
	break;
    case 'h': histo(&amat,&bmat); break;
    case 'j': rvers(&amat,&bmat); break;
    case 'l':
	mmat(&hmat,&gmat,&gmat);
	mmat(&fmat,&hmat,&hmat);
	mmat(&hmat,&fmat,&fmat);
	mmat(&fmat,&gmat,&hmat);
	a=tsum(&hmat);
	b=tsum(&fmat);
	pmat(&gmat,8,5);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,18,0); printf("%3u %3u",a,b);
	videocursor(0,20,0); printf("  %6.3f",bb);
	break;
    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
        printf("      freq,   ave, 2d mom,    var\n");
	  for (i0=0; i0<K3+1; i0++)
	    {f=sta[0][i0]; if (f>0.0) {
	    g=sta[1][i0]/f;
	    h=sta[2][i0]/f;
	    e=sqrt(h-g*g);
            printf("%1u%1u %6.0f, %6.3f, %6.2f, %6.3f\n",K3-i0,i0,f,g,h,e);
	    }}
	f=sta[0][4]-stt; if (f>0.0) {
	    g=(sta[1][4]-2.0*stt)/f;
	    h=(sta[2][4]-4.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("-- %6.0f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("tt %6.0f, %6.3f, %6.2f, %6.3f\n",stt,2.0,4.0,0.0);
	break;
    case 't':
	ll=1;
	ppmat(&tmat,5,21);
	qqmat(&tmat,150,50);
	umat=tmat;
	t=ttsum(&tmat);
	s=nnzel(&tmat);
	f=(double)t;
	g=f/kay;
	h=kay;
	videocursor(0,22,25); printf("t=%3u, s=%3u ",t,s);
	f=(double)t;
	break;
    case 'u':			/* variance of eigenvector components	*/
	if (tt==0) {videocursor(0,1,0); printf("T required first"); break;}
	auua(&xave,&xsig,&ex,&wy,cvec,xvec,&umat);
	videocursor(0,22,0); printf("av%6.3f, va%6.3f",xave,xsig);
	videocursor(0,24,0); printf(" +%6.3f, ..%6.3f",wy,ex);
	break;
    case 'v':			/* variance of column sums 		*/
	avva(&cave,&csig,cvec,&tmat);
	videocursor(0,23,0); printf("av%6.3f, va%6.3f",cave,csig);
	break;
    case 'w':
      videoscroll(1,0,24,39,0,0);
      videocursor(0,1,0);
      if (ss==0) {printf("S required first"); break;}
      printf("       min,    ave,    max,  nominal\n");
        for (i0=0; i0<K3+1; i0++)
	  {f=sta[0][i0]; if (f>0.0) {
	  e=sta[1][i0]/f;
          g=sta[3][i0];
          h=sta[4][i0];
	  ff=((double)(i0*i0+(K3-i0)*(K3-i0)))/kk4;
          printf("%1u%1u  %6.3f, %6.3f, %6.3f, (%6.3f)\n",K3-i0,i0,g,e,h,ff);
          }}
      break;
    case 'A':
	l++;
	mmat(&hmat,&amat,&gmat);
	gmat=hmat;
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'B':
	l++;
	mmat(&hmat,&bmat,&gmat);
	gmat=hmat;
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'Q':
	l*=2;
	mmat(&hmat,&gmat,&gmat);
	gmat=hmat;
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'S':
      for (i0=0; i0<5; i0++) for (i1=0; i1<K3+1; i1++) sta[i0][i1]=0.0;
      for (i1=0; i1<K3+1; i1++) sta[3][i1]=10.0;
      stt=0.0;
      allmo(&stt,sta);
      ss=1;
      break;
    case 'T':
	ll++;
	mmmat(&vmat,&tmat,&umat);
	ccymat(&umat,&vmat);
	ppmat(&umat,5,21);
	qqmat(&umat,150,50);
	t=ttsum(&umat);
	s=nnzel(&umat);
	ff=f; f=(double)t;
	h=h*kay;
	gg=g; g=f/h;
	videocursor(0,22,18); printf("%7u [%3u]%6.3f  ",t,s,f/ff);
	videocursor(0,23,20); printf("m[2] ratio:%6.3f ",sqrt(f/ff));
	gr=g/gg; gl=0.0; if (gr>0.0) gl=log(gr);
	go=g*exp(-((double)(ll-1))*gl);
	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
	tt=1;
	break;
    case 'X':
	l+=m;
	mmat(&hmat,&xmat,&gmat);
	gmat=hmat;
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
//	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case '=': m=l; xmat=gmat; break;
    case '/': videoscroll(1,0,24,39,0,0); break;
    case '.':
//	videoscroll(1,0,24,39,0,0);
	pmat(&amat,1,0);
	pmat(&bmat,1,10);
	videocursor(0,16,2); printf("a=%1u",t0);
	videocursor(0,16,8); printf("b=%1u",t1);
	pmat(&gmat,8,5);
	break;
    case '?': clard(); break;

    default: break;
    } /* end switch */
  }   /* end while  */
//   videopalette(WHCYMAG);
//   videomode(T80X25);
}

/* calculate the first two moments of all rules */
void allmo(stt,sta) double *stt, sta[5][K3+1]; {
twoparn tmat, umat, vmat;
parneih amat, bmat;
int     ig, ih, hg[301];
int     i, i0, i1, i2, i3, i4, i5, i6, i7;
int     t0, t1, t2;
double  f, g, ff;
  i=0;
  for (i0=0;  i0<301; i0++)   hg[i0]=0;
//  for (i0=10; i0<360; i0+=50) videodot( 99,i0,1);
//  for (i0=10; i0<360; i0+=50) videodot(199,i0,1);
  for (i0=0; i0<KK; i0++) {binrule[0][0][0]=i0;
  for (i1=0; i1<KK; i1++) {binrule[0][0][1]=i1;
  for (i2=0; i2<KK; i2++) {binrule[0][1][0]=i2;
  for (i3=0; i3<KK; i3++) {binrule[0][1][1]=i3;
  for (i4=0; i4<KK; i4++) {binrule[1][0][0]=i4;
  for (i5=0; i5<KK; i5++) {binrule[1][0][1]=i5;
  for (i6=0; i6<KK; i6++) {binrule[1][1][0]=i6;
  for (i7=0; i7<KK; i7++) {binrule[1][1][1]=i7;
    zmat(&amat);  djmat(&amat,0);
    zmat(&bmat);  djmat(&bmat,1);
    zmat(&cmat);  djmat(&bmat,2);
    zzmat(&tmat); tensq(&tmat,&amat,&bmat,&cmat);
    t0=tsum(&amat);
    t1=tsum(&bmat);
    t2=tsum(&bmat);
    if (t0<=t1)
      {
      mmmat(&vmat,&tmat,&tmat);
      mmmat(&umat,&tmat,&vmat);
      mmmat(&vmat,&tmat,&umat);
      ff=(double)ttsum(&umat);
      f= (double)ttsum(&vmat);
      g=f/ff;
      ig=(int)(300.0*((g-2.0)/(4.0-2.0)));
      hg[ig]++;
      ih=hg[ig]; if (ih>100) ih=100+ih/10;
      videodot(ih,10+ig,2);
      sta[0][t0]+=1.0;
      sta[1][t0]+=g; sta[2][t0]+=g*g;
      if (sta[3][t0]>=g) sta[3][t0]=g;
      if (sta[4][t0]<=g) sta[4][t0]=g;
      if (g==2.0) *stt+=1.0;
      }
    i++;
    }}}}}}}}
}

/* calculate tensor square axa+bxb+cxc */
void tensq(tmat,amat,bmat,cmat) twoparn *tmat; parneih *amat, *bmat, *cmat; {
int i0, i1, i2, i3, i4, i5, i6, i7;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  tmat->eight[i0][i1][i2][i3][i4][i5][i6][i7]+=
	amat->four[i0][i1][i4][i5]*amat->four[i2][i3][i6][i7]+
	bmat->four[i0][i1][i4][i5]*bmat->four[i2][i3][i6][i7]+
	cmat->four[i0][i1][i4][i5]*cmat->four[i2][i3][i6][i7];
  }
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

void clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  woruno(0,22);
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("ab  - 0,1 matrix\n");
  printf("AB  - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Q   - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ssw - all rules \n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}

void rvers(amat,bmat) parneih *amat, *bmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
int    i0, i1, i2, i3, i4, i5;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
int    t5[KK][KK][KK][KK][KK], t6[KK][KK][KK][KK][KK][KK];
double s, t, u, kk1, kk2, kk3, kk4, kk5, kk6;

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
kk5=(double)K5;
kk6=(double)K6;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);
t1[0]=tsum(&m1[0]);
t1[1]=tsum(&m1[1]);
// videocursor(0,2,0); printf("%3u,%3u",t1[0],t1[1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  printf("%3u,",t3[i0][i1][i2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&xmat,&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&xmat);
  }
videocursor(0,8,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  mmat(&xmat,&m2[i0][i1],&m3[i2][i3][i4]);
  t5[i0][i1][i2][i3][i4]=tsum(&xmat);
  }
videocursor(0,11,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    printf("%3u,",t5[i0][i1][i2][i3][i4]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(&xmat,&m3[i0][i1][i2],&m3[i3][i4][i5]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(&xmat);
  }
videocursor(0,16,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
    printf("%3u,",t6[i0][i1][i2][i3][i4][i5]);
  printf("\n");
  }

for (i0=0,s=0.0; i0<KK; i0++) {t=((double)(t1[i0]-AV)); s+=t*t;}
t=sqrt(s/kk1);
videocursor(0,2,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {t=((double)(t2[i0][i1]-AV)); s+=t*t;}
t=sqrt(s/kk2);
videocursor(0,4,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); s+=t*t;}
t=sqrt(s/kk3);
videocursor(0,6,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); s+=t*t;}
t=sqrt(s/kk4);
videocursor(0,9,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {t=((double)(t5[i0][i1][i2][i3][i4]-AV)); s+=t*t;}
t=u=sqrt(s/kk5);
videocursor(0,14,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
videocursor(0,23,33); printf("%6.2f",t);

s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("ratio: %6.2f",s);

}

void histo(amat,bmat) parneih *amat, *bmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[AV*K8+1];
char   c[30];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<AV*K8+1; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  h8[t8[i0][i1][i2][i3][i4][i5][i6][i7]]++;

po=da=0;
for (i=0; i<60; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
//  videocursor(0,i0+1,13*i1+1);
  sprintf(c,"%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("total: %3u in %3u pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond: %3u, %3u",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);

}

/* test whether the rule is reversible */
void revert() {
int revrule[KK][KK][KK];
int i0,i1,i2;
//  videocursor(0,17,0); printf(".");
  if (runiq(binrule,revrule)) {
//    videocursor(0,17,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
      printf("%1d",revrule[i0][i1][i2]);
    printf("\n");
    }
//  videocursor(0,18,0); printf(".");
return;
  if (suniq(binrule)) {
    videocursor(0,18,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
      printf("%1d",binrule[i0][i1][i2]);
    printf("\n");
    }
  videocursor(0,19,0); printf(".");
  if (tuniq(binrule)) {
    videocursor(0,19,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
      printf("%1d",binrule[i0][i1][i2]);
    printf("\n");
    }
}

/* make a list of the reversible rules */

void rever() {
char chb[10], chc[10];
char ii[12][KK][KK][KK], wanum[12][10], wbnum[12][10];
char asqrule[KK][KK][KK], bsqrule[KK][KK][KK];
int kay[KK];
int         brul[KK][KK][KK];
int         crul[KK][KK][KK];
int     drul[KK][KK][KK][KK][KK];
int erul[KK][KK][KK][KK][KK][KK][KK];
int i000,i001,i002,i010,i011,i012,i020,i021,i022;
int i100,i101,i102,i110,i111,i112,i120,i121,i122;
int i200,i201,i202,i210,i211,i212,i220,i221,i222;
int j0,j1,j2,j3,j4,j5;
int i, k, kk, l, m, mm, nn;
printf("hello from rever\n");
k=kk=l=m=0;
for (i=0; i<KK; i++) kay[i]=0;
i=0;
printf("reversibles - unicycles\n");
for (i000=0; i000<KK; i000++) {brul[0][0][0]=i000;
	if (kay[i000]>(KK*KK)) break; kay[i000]++;
for (i111=0; i111<KK; i111++) {brul[1][1][1]=i111;
	if (i111==i000) continue;
	if (kay[i111]>(KK*KK)) break; kay[i111]++;
for (i222=0; i222<KK; i222++) {brul[2][2][2]=i222;
	if (i222==i000) continue;
	if (i222==i111) continue;
	if (kay[i222]>(KK*KK)) break; kay[i222]++;

printf("reversibles - bicycles\n");
for (i010=0; i010<KK; i010++) {brul[0][1][0]=i010;
	 if (kay[i010]>(KK*KK)) break; kay[i010]++; 
for (i101=0; i101<KK; i101++) {brul[1][0][1]=i101;
	 if (i010==i101) continue;
	 if (kay[i101]>(KK*KK)) break; kay[i101]++;

for (i020=0; i020<KK; i020++) {brul[0][2][0]=i020;
	 if (kay[i020]>(KK*KK)) break; kay[i020]++;
for (i202=0; i202<KK; i202++) {brul[2][0][2]=i202;
	 if (i020==i202) continue;
	 if (i020==i010&&i202==i101) continue;
	 if (i020==i101&&i202==i010) continue;
	 if (kay[i202]>(KK*KK)) break; kay[i202]++;

for (i121=0; i121<KK; i121++) {brul[1][2][1]=i121;
	 if (kay[i121]>(KK*KK)) break; kay[i121]++;
for (i212=0; i212<KK; i212++) {brul[2][1][2]=i212;
	 if (i121==i212) continue;
	 if (i121==i010&&i212==i101) continue;
	 if (i121==i101&&i212==i010) continue;
	 if (i121==i020&&i212==i202) continue;
	 if (i121==i202&&i212==i020) continue;
	 if (kay[i212]>(KK*KK)) break; kay[i212]++;

// printf("reversibles - tricycles\n");
for (i001=0; i001<KK; i001++) {brul[0][0][1]=i001;
	 if (kay[i001]>(KK*KK)) break; kay[i001]++;
for (i100=0; i100<KK; i100++) {brul[1][0][0]=i100;
	 if (i001==i010&&i010==i100) continue;
	 if (kay[i100]>(KK*KK)) break; kay[i100]++;

for (i002=0; i002<KK; i002++) {brul[0][0][2]=i002;
	 if (kay[i002]>(KK*KK)) break; kay[i002]++;
for (i200=0; i200<KK; i200++) {brul[2][0][0]=i200;
	 if (i002==i020&&i020==i200) continue;
	 if (i002==i001&&i020==i010&&i200==i100) continue;
	 if (i002==i010&&i020==i100&&i200==i001) continue;
	 if (i002==i100&&i020==i001&&i200==i010) continue;
	 if (kay[i200]>(KK*KK)) break; kay[i200]++;

for (i011=0; i011<KK; i011++) {brul[0][1][1]=i011;
	 if (kay[i011]>(KK*KK)) break; kay[i011]++;
for (i110=0; i110<KK; i110++) {brul[1][1][0]=i110;
	 if (i011==i110&&i110==i101) continue;
	 if (i011==i001&&i110==i010&&i101==i100) continue;
	 if (i011==i010&&i110==i100&&i101==i001) continue;
	 if (i011==i100&&i110==i001&&i101==i010) continue;
	 if (i011==i002&&i110==i020&&i101==i200) continue;
	 if (i011==i020&&i110==i200&&i101==i002) continue;
	 if (i011==i200&&i110==i002&&i101==i020) continue;
	 if (kay[i110]>(KK*KK)) break; kay[i110]++;

// printf("old MacDonald had a farm\n");

for (i022=0; i022<KK; i022++) {brul[0][2][2]=i022;
	 if (kay[i022]>(KK*KK)) break; kay[i022]++;
for (i220=0; i220<KK; i220++) {brul[2][2][0]=i220;
	 if (i022==i220&&i220==i202) continue;
	 if (i022==i001&&i220==i010&&i202==i100) continue;
	 if (i022==i010&&i220==i100&&i202==i001) continue;
	 if (i022==i100&&i220==i001&&i202==i010) continue;
	 if (i022==i002&&i220==i020&&i202==i200) continue;
	 if (i022==i020&&i220==i200&&i202==i002) continue;
	 if (i022==i200&&i220==i002&&i202==i020) continue;
	 if (i022==i011&&i220==i110&&i202==i101) continue;
	 if (i022==i110&&i220==i101&&i202==i011) continue;
	 if (i022==i101&&i220==i011&&i202==i110) continue;
	 if (kay[i220]>(KK*KK)) break; kay[i220]++;

for (i112=0; i112<KK; i112++) {brul[1][1][2]=i112;
	 if (kay[i112]>(KK*KK)) break; kay[i112]++;
for (i211=0; i211<KK; i211++) {brul[2][1][1]=i211;
	 if (i112==i121&&i121==i211) continue;
	 if (i112==i001&&i121==i010&&i211==i100) continue;
	 if (i112==i010&&i121==i100&&i211==i001) continue;
	 if (i112==i100&&i121==i001&&i211==i010) continue;
	 if (i112==i002&&i121==i020&&i211==i200) continue;
	 if (i112==i020&&i121==i200&&i211==i002) continue;
	 if (i112==i200&&i121==i002&&i211==i020) continue;
	 if (i112==i011&&i121==i110&&i211==i101) continue;
	 if (i112==i110&&i121==i101&&i211==i011) continue;
	 if (i112==i101&&i121==i011&&i211==i110) continue;
	 if (i112==i022&&i121==i220&&i211==i202) continue;
	 if (i112==i220&&i121==i202&&i211==i022) continue;
	 if (i112==i202&&i121==i022&&i211==i220) continue;
	 if (kay[i211]>(KK*KK)) break; kay[i211]++;

for (i122=0; i122<KK; i122++) {brul[1][2][2]=i122;
	 if (kay[i122]>(KK*KK)) break; kay[i122]++;
for (i221=0; i221<KK; i221++) {brul[2][2][1]=i221;
	 if (i122==i221&&i221==i212) continue;
	 if (i122==i001&&i221==i010&&i212==i100) continue;
	 if (i122==i010&&i221==i100&&i212==i001) continue;
	 if (i122==i100&&i221==i001&&i212==i010) continue;
	 if (i122==i002&&i221==i020&&i212==i200) continue;
	 if (i122==i020&&i221==i200&&i212==i002) continue;
	 if (i122==i200&&i221==i002&&i212==i020) continue;
	 if (i122==i011&&i221==i110&&i212==i101) continue;
	 if (i122==i110&&i221==i101&&i212==i011) continue;
	 if (i122==i101&&i221==i011&&i212==i110) continue;
	 if (i122==i022&&i221==i220&&i212==i202) continue;
	 if (i122==i220&&i221==i202&&i212==i022) continue;
	 if (i122==i202&&i221==i022&&i212==i220) continue;
	 if (i122==i112&&i221==i121&&i212==i211) continue;
	 if (i122==i121&&i221==i211&&i212==i112) continue;
	 if (i122==i211&&i221==i112&&i212==i121) continue;
	 if (kay[i221]>(KK*KK)) break; kay[i221]++;

for (i012=0; i012<KK; i012++) {brul[0][1][2]=i012;
	 if (kay[i012]>(KK*KK)) break; kay[i012]++;
for (i120=0; i120<KK; i120++) {brul[1][2][0]=i120;
	 if (kay[i120]>(KK*KK)) break; kay[i120]++;
for (i201=0; i201<KK; i201++) {brul[2][0][1]=i201;
	 if (i012==i120&&i120==i201) continue;
	 if (i012==i001&&i120==i010&&i201==i100) continue;
	 if (i012==i010&&i120==i100&&i201==i001) continue;
	 if (i012==i100&&i120==i001&&i201==i010) continue;
	 if (i012==i002&&i120==i020&&i201==i200) continue;
	 if (i012==i020&&i120==i200&&i201==i002) continue;
	 if (i012==i200&&i120==i002&&i201==i020) continue;
	 if (i012==i011&&i120==i110&&i201==i101) continue;
	 if (i012==i110&&i120==i101&&i201==i011) continue;
	 if (i012==i101&&i120==i011&&i201==i110) continue;
	 if (i012==i022&&i120==i220&&i201==i202) continue;
	 if (i012==i220&&i120==i202&&i201==i022) continue;
	 if (i012==i202&&i120==i022&&i201==i220) continue;
	 if (i012==i112&&i120==i121&&i201==i211) continue;
	 if (i012==i121&&i120==i211&&i201==i112) continue;
	 if (i012==i211&&i120==i112&&i201==i121) continue;
	 if (i012==i122&&i120==i221&&i201==i212) continue;
	 if (i012==i221&&i120==i212&&i201==i122) continue;
	 if (i012==i212&&i120==i122&&i201==i221) continue;
	 if (kay[i201]>(KK*KK)) break; kay[i201]++;

for (i021=0; i021<KK; i021++) {brul[0][2][1]=i021;
	 if (kay[i021]>(KK*KK)) break; kay[i021]++;
for (i210=0; i210<KK; i210++) {brul[2][1][0]=i210;
	 if (kay[i210]>(KK*KK)) break; kay[i210]++;
for (i102=0; i102<KK; i102++) {brul[1][0][2]=i102;
	 if (i021==i210&&i210==i102) continue;
	 if (i021==i001&&i210==i010&&i102==i100) continue;
	 if (i021==i010&&i210==i100&&i102==i001) continue;
	 if (i021==i100&&i210==i001&&i102==i010) continue;
	 if (i021==i002&&i210==i020&&i102==i200) continue;
	 if (i021==i020&&i210==i200&&i102==i002) continue;
	 if (i021==i200&&i210==i002&&i102==i020) continue;
	 if (i021==i011&&i210==i110&&i102==i101) continue;
	 if (i021==i110&&i210==i101&&i102==i011) continue;
	 if (i021==i101&&i210==i011&&i102==i110) continue;
	 if (i021==i022&&i210==i220&&i102==i202) continue;
	 if (i021==i220&&i210==i202&&i102==i022) continue;
	 if (i021==i202&&i210==i022&&i102==i220) continue;
	 if (i021==i112&&i210==i121&&i102==i211) continue;
	 if (i021==i121&&i210==i211&&i102==i112) continue;
	 if (i021==i211&&i210==i112&&i102==i121) continue;
	 if (i021==i122&&i210==i221&&i102==i212) continue;
	 if (i021==i221&&i210==i212&&i102==i122) continue;
	 if (i021==i212&&i210==i122&&i102==i221) continue;
	 if (i021==i012&&i210==i120&&i102==i201) continue;
	 if (i021==i120&&i210==i201&&i102==i012) continue;
	 if (i021==i201&&i210==i012&&i102==i120) continue;
	 if (kay[i102]>(KK*KK)) break; kay[i102]++;

	kk++;

  if (runiq(brul,crul)) {
	     byntoasc(asqrule,brul);
	     byntoasc(bsqrule,crul);
	     mm=allperm(wanum,ii,asqrule);
	     nn=allperm(wbnum,ii,bsqrule);
	     wrru(chb,asqrule);
	     wrru(chc,bsqrule);
	     printf("runiq: %s   %s   %s  %s (%3d)/%3d\n",
		    wanum[mm],chb,chc,wbnum[nn],++k,kk);
	     kk=0;

//    printf("runiq, k = %3d: ",++k);
//    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) for (j2=0; j2<KK; j2++) 
//	printf("%1d",brul[j0][j1][j2]);
//    printf(" --- ");
//    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) for (j2=0; j2<KK; j2++)
//	printf("%1d",crul[j0][j1][j2]);
//    printf("\n");
    }

//  if (suniq(brul,drul)) {
//    printf("suniq, l = %3d: ",++l);
//    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
//    printf(" ---\n");
//     for (j0=0; j0<KK; j0++)
//       { 
//       for (j1=0; j1<KK; j1++) 
//       for (j2=0; j2<KK; j2++) for (j3=0; j3<KK; j3++)
// 	printf("%1d",drul[j0][j1][j2][j3]);
//       printf("\n");
//       } /* end for */
//    }   /* end if  */
//   if (tuniq(brul,erul)) {
//     printf("tuniq, m = %3d: ",++m);
//     for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
//     printf(" ---\n");
//     for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++)
//     for (j2=0; j2<KK; j2++)
//       { 
//       for (j3=0; j3<KK; j3++) 
//       for (j4=0; j4<KK; j4++) for (j5=0; j5<KK; j5++)
// 	printf("%1d",erul[j0][j1][j2][j3][j4][j5]);
//       printf("\n");
//       } /* end for */
//     }   /* end if  */


  kay[i102]--;}
  kay[i210]--;}
  kay[i021]--;}
  kay[i201]--;}
  kay[i120]--;}
  kay[i012]--;}

  kay[i221]--;}
  kay[i122]--;}
  kay[i211]--;}
  kay[i112]--;}
  kay[i220]--;}
  kay[i022]--;}
  kay[i110]--;}
  kay[i011]--;}
  kay[i200]--;}
  kay[i002]--;}
  kay[i100]--;}
  kay[i001]--;}

  kay[i212]--;}
  kay[i121]--;}
  kay[i202]--;}
  kay[i020]--;}
  kay[i101]--;}
  kay[i010]--;}

  kay[i222]--;}
  kay[i111]--;}
  kay[i000]--;}
}

/* fill ascrule from binrule */
void byntoasc(as,bi) char as[KK][KK][KK]; int bi[KK][KK][KK]; 
{int i0, i1, i2; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
    as[i0][i1][i2]=bi[i0][i1][i2]+'0';
}



int ufmult() {
int j, j0, j1, j2, m[KK];
asctobin();
for (j=0; j<KK; j++) m[j]=0;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
  m[binrule[j0][j1][j2]]++;
for (j=1; j<KK; j++) if (m[j]!=m[0]) return 0;
return 1;
}

/* survey the composite (3,1/2) rules */
void squruls() {
char chb[10];
char ii[12][KK][KK][KK], wnum[12][10];
char asqrule[KK][KK][KK];
int  arul[KK][KK], brul[KK][KK], crul[KK][KK][KK];
int  i00, i01, i02, i10, i11, i12, i20, i21, i22;
int  j00, j01, j02, j10, j11, j12, j20, j21, j22;
int  k0, k1, k2;
int  mm;

for (i00=0; i00<KK; i00++) 
for (i01=0; i01<KK; i01++) 
for (i02=0; i02<KK; i02++) 
for (i10=0; i10<KK; i10++) 
for (i11=0; i11<KK; i11++) 
for (i12=0; i12<KK; i12++) 
for (i20=0; i20<KK; i20++) 
for (i21=0; i21<KK; i21++) 
for (i22=0; i22<KK; i22++)

//for (j00=0; j00<KK; j00++) 
//for (j01=0; j01<KK; j01++) 
//for (j02=0; j02<KK; j02++) 
//for (j10=0; j10<KK; j10++) 
//for (j11=0; j11<KK; j11++) 
//for (j12=0; j12<KK; j12++) 
//for (j20=0; j20<KK; j20++) 
//for (j21=0; j21<KK; j21++) 
//for (j22=0; j22<KK; j22++)
  {

  arul[0][0]=i00;
  arul[0][1]=i01;
  arul[0][2]=i02;
  arul[1][0]=i10;
  arul[1][1]=i11;
  arul[1][2]=i12;
  arul[2][0]=i20;
  arul[2][1]=i21;
  arul[2][2]=i22;

  for (k0=0; k0<KK; k0++)
  for (k1=0; k1<KK; k1++)
  for (k2=0; k2<KK; k2++) {
    crul[k0][k1][k2]=arul[arul[k0][k1]][arul[k1][k2]];
    }
	     byntoasc(asqrule,crul);
	     mm=allperm(wnum,ii,asqrule);
	     wrru(chb,asqrule);
	     printf("square: %s   %s\n",wnum[mm],chb);
  }
}

int runiq(brul,rrul) 
int brul[KK][KK][KK], rrul[KK][KK][KK]; {
int a, b, d;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
  rrul[j0][j1][j2]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
  {
  a=brul[j0][j1][j2];
  b=brul[j1][j2][j3];
  d=brul[j2][j3][j4];
  if (rrul[a][b][d]==KK) rrul[a][b][d]=j2;
  if (rrul[a][b][d]!=j2) return(0);
  }
return(1);
}

int suniq(brul) int brul[KK][KK][KK]; {
int a, b, e, f, g, c[KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
  c[j0][j1][j2][j3][j4]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
  {
  a=brul[j0][j1][j2];
  b=brul[j1][j2][j3];
  e=brul[j2][j3][j4];
  f=brul[j3][j4][j5];
  g=brul[j4][j5][j6];
  if (c[a][b][e][f][g]==KK) c[a][b][e][f][g]=j3;
  if (c[a][b][e][f][g]!=j3) return(0);
  }
return(1);
}

int tuniq(brul) int brul[KK][KK][KK]; {
int a, b, e, f, g, h, i, c[KK][KK][KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6, j7, j8;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
  c[j0][j1][j2][j3][j4][j5][j6]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
  {
  a=brul[j0][j1][j2];
  b=brul[j1][j2][j3];
  e=brul[j2][j3][j4];
  f=brul[j3][j4][j5];
  g=brul[j4][j5][j6];
  h=brul[j5][j6][j7];
  i=brul[j6][j7][j8];
  if (c[a][b][e][f][g][h][i]==KK) c[a][b][e][f][g][h][i]=j4;
  if (c[a][b][e][f][g][h][i]!=j4) return(0);
  }
return(1);
}

/* make a list of square root rules */

void squrt() {
char chb[10];
char asqrule[KK][KK][KK];
int         brul[KK][KK][KK];
int i000,i001,i002,i010,i011,i012,i020,i021,i022;
int i100,i101,i102,i110,i111,i112,i120,i121,i122;
int i200,i201,i202,i210,i211,i212,i220,i221,i222;
int i, k, l, m, mm;
printf("hello from squrt\n");
k=l=m=0;
i=0;
printf("reversibles - unicycles\n");
for (i000=0; i000<KK; i000++) {brul[0][0][0]=i000;
for (i111=0; i111<KK; i111++) {brul[1][1][1]=i111;
for (i222=0; i222<KK; i222++) {brul[2][2][2]=i222;
for (i010=0; i010<KK; i010++) {brul[0][1][0]=i010;
for (i101=0; i101<KK; i101++) {brul[1][0][1]=i101;
for (i020=0; i020<KK; i020++) {brul[0][2][0]=i020;
for (i202=0; i202<KK; i202++) {brul[2][0][2]=i202;
for (i121=0; i121<KK; i121++) {brul[1][2][1]=i121;
for (i212=0; i212<KK; i212++) {brul[2][1][2]=i212;
for (i001=0; i001<KK; i001++) {brul[0][0][1]=i001;
for (i100=0; i100<KK; i100++) {brul[1][0][0]=i100;
for (i002=0; i002<KK; i002++) {brul[0][0][2]=i002;
for (i200=0; i200<KK; i200++) {brul[2][0][0]=i200;
for (i011=0; i011<KK; i011++) {brul[0][1][1]=i011;
for (i110=0; i110<KK; i110++) {brul[1][1][0]=i110;
for (i022=0; i022<KK; i022++) {brul[0][2][2]=i022;
for (i220=0; i220<KK; i220++) {brul[2][2][0]=i220;
for (i112=0; i112<KK; i112++) {brul[1][1][2]=i112;
for (i211=0; i211<KK; i211++) {brul[2][1][1]=i211;
for (i122=0; i122<KK; i122++) {brul[1][2][2]=i122;
for (i221=0; i221<KK; i221++) {brul[2][2][1]=i221;
for (i012=0; i012<KK; i012++) {brul[0][1][2]=i012;
for (i120=0; i120<KK; i120++) {brul[1][2][0]=i120;
for (i201=0; i201<KK; i201++) {brul[2][0][1]=i201;
for (i021=0; i021<KK; i021++) {brul[0][2][1]=i021;
for (i210=0; i210<KK; i210++) {brul[2][1][0]=i210;
for (i102=0; i102<KK; i102++) {brul[1][0][2]=i102;

    if (issqr(brul)==1) {
	     byntoasc(asqrule,brul);
	     wrru(chb,asqrule);
	     printf("squrt: %s (%3d)\n",chb,++k);
	     }

}}}}}}}}}
}}}}}}}}}
}}}}}}}}}
}

/* see if it is a square */
int issqr(brul) int brul[KK][KK][KK]; {
int j0, j1, j2, j3, j4;
int k0, k1, k2;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  k0=brul[j0][j1][j2];
  k1=brul[j1][j2][j3];
  k2=brul[j2][j3][j4];
  if (brul[k0][k1][k2]!=j2) return 0;
  }
  return 1;
}

/* print matrix */
void pmat(z,i,j) int i, j; parneih *z; {
int i0, i1, i2, i3;
videocursor(0,1,0);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {
    videocursor(0,i+i0*KK+i1,j);
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      printf("%1d",z->four[i0][i1][i2][i3]);
    }
}

/* display K4xK4 matrix */
void ppmat(z,i,j) int i, j; twoparn *z; {
int i0, i1;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {videocursor(0,i+i0,j+i1); printf("%1d",z->two[i0][i1]);}
}

/* display K4xK4 matrix */
void qqmat(z,i,j) int i, j; twoparn *z; {
int i0, i1, k, l;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {
  k=0; l=z->two[i0][i1];
  if (l==1) k=1;
  if (l>=2) k=2;
  if (l>=4) k=3;
  videodot(i+i0,j+i1,k);
  }
}

/* total matrix elements */
unsigned int tsum(z) parneih *z; {int t, i;
for (i=t=0; i<K2*K2; i++) t+=z->one[i]; return t;}

/* total matrix elements */
unsigned int ttsum(z) twoparn *z; {int t, i;
for (i=t=0; i<K4*K4; i++) t+=z->one[i]; return t;}

/* count nonzero matrix elements */
unsigned int nzel(z) parneih *z; {int t, i;
for (i=t=0; i<K2*K2; i++) if (z->one[i]!=0) t++; return t;}

/* count nonzero matrix elements */
unsigned int nnzel(z) twoparn *z; {int t, i;
for (i=t=0; i<K4*K4; i++) if (z->one[i]!=0) t++; return t;}

/* calculate row sums */
void rowsum(x,z) int x[KK][KK]; parneih *z; {int i0, i1, j0, j1;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  x[i0][i1]=0;
  for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) 
	x[i0][i1]+=z->four[i0][i1][j0][j1];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK][KK]; parneih *z; {int i0, i1, j0, j1;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) {
  x[j0][j1]=0;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
	x[j0][j1]+=z->four[i0][i1][j0][j1];
  }
}

/* copy one K2xK2 matrix from another: z=x */
void cymat(z,x) parneih *z, *x; {int i; 
for (i=0; i<K2*K2; i++) z->one[i]=x->one[i];}

/* copy one K4xK4 matrix from another: z=x */
void ccymat(z,x) twoparn *z, *x; {int i;
  for (i=0; i<K8; i++) z->one[i]=x->one[i];}

/* multiply K2xK2 matrices */
void mmat(z,x,y) parneih *z, *x, *y;
{
int i0, i1, i2;
  for (i0=0; i0<K2; i0++)
  for (i2=0; i2<K2; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply K4xK4 matrices */
void mmmat(z,x,y) twoparn *z, *x, *y; {
int i0, i1, i2;
  for (i0=0; i0<K4; i0++)
  for (i2=0; i2<K4; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K4; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) parneih *z; int l; {
int i0, i1, i2;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    z->four[i2][i1][i1][i0]=(binrule[i0][i1][i2]==l)?1:0;
}

/* generate a K4xK4 unit matrix */
void unmat(z) twoparn *z; {int i; zzmat(z); for (i=0; i<K4; i++) z->two[i][i]=1;}

/* zero a K2xK2 matrix */
void zmat(z) parneih *z; {int i; for (i=0; i<K4; i++) z->one[i]=0;}

/* zero a K4xK4 matrix */
void zzmat(z) twoparn *z; {int i; for (i=0; i<K4*K4; i++) z->one[i]=0;}

/* average and variance of eigenvector components */
/* supposes that a valid cve already exists	  */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 twoparn *mat; {
int    i, j;
double a, v, p, q, r, kk4;
kk4=(double)K4;
for (i=0; i<K4; i++)
for (vec[i]=0.0, j=0; j<K4; j++)
  vec[i]+=(double)mat->two[j][i];
for (a=0.0, i=0; i<K4; i++) a+=vec[i];
for (i=0; i<K4; i++) vec[i]/=a;
a=1.0/kk4;
for (i=0; i<K4; i++) vec[i]-=a;
for (v=0.0, i=0; i<K4; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K4; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk4);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; twoparn *mat; {
int    i, j;
double a, v, kk4;
kk4=(double)K4;
for (i=0; i<K4; i++)
for (vec[i]=0.0, j=0; j<K4; j++)
  vec[i]+=(double)mat->two[i][j];
for (a=0.0, i=0; i<K4; i++) a+=vec[i];
a/=kk4;
for (i=0; i<K4; i++) vec[i]-=a;
for (v=0.0, i=0; i<K4; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk4);
}

/* end nxardn61.c */
